﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win;

namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraGrid1.CreationFilter = new CreationUIElement();
            DataTable dt = new DataTable();
            for (int i = 0; i < 400; i++)
            {
                dt.Columns.Add("Column " + i.ToString(), typeof(string));
            }

            for (int k = 0; k < 1000; k++)
            {
                object[] dr = new object[400];
                for (int i = 0; i < 400; i++)
                {
                    dr[i] = "Test Item " + k.ToString() + " - " + i.ToString();
                }
                dt.Rows.Add(dr);
            }

            ultraGrid1.DataSource = dt;
        }
    }

    public class CreationUIElement : IUIElementCreationFilter
    {
        #region IUIElementCreationFilter Members

        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            if (parent is RowColRegionIntersectionUIElement)
            {
                List<UIElement> elementsToRemove = new List<UIElement>();
                foreach (UIElement element in parent.ChildElements)
                {
                    RowUIElement rowUIElement = element as RowUIElement;
                    if (rowUIElement == null)
                        continue;
                    if (rowUIElement.Rect.Bottom > parent.Rect.Bottom)
                    {
                        RowUIElement prevRow = parent.ChildElements[rowUIElement.Row.Index] as RowUIElement;
                         if (prevRow.Rect.Bottom < parent.Rect.Bottom ) prevRow.Row.Height += 1;
                        elementsToRemove.Add(element);
                    }
                }
                foreach (UIElement element in elementsToRemove)
                {
                    parent.ChildElements.Remove(element);
                }
            }
        }
        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }

        #endregion
    }
}
